<!DOCTYPE html>
<html lang="en">
    <head>
        <link rel="stylesheet" type="text/css" href="https://pyscript.net/alpha/pyscript.css"/>
        <link rel="stylesheet" type="text/css" href="static/style.css"/>

        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>DRB Python Training</title>
        <script defer src="https://pyscript.net/alpha/pyscript.js"></script>
        <script src="static/check.js"></script>

        <title>
            <b>DRB Python Training</b>
        </title>
    </head>

    <py-env>
        - importlib-metadata
        - PyYaml
        - 'static/lib/drb-1.0.8+3.gd962af8.dirty-py3-none-any.whl'
    </py-env>

    <article class="my_body">
        <h1 class="big_title">
            DrbNode
        </h1>

        <section>
            <h2 class="chapter">
                DrbNode API
            </h2>


            <img src="static/images/drbNode.jpeg">
            <br>
            
            <p>
                A DrbNode is a generic node interface. This interface represents a single node of a tree of data. 
                Any node can have no, one or several children. This interface provides the primarily operations to browse an entire data structure.<br>
                All implementations of the “Data Request Broker” shall be able to produce such nodes.<br>
                For the next exemple we will use DrbLogicalNode which implements DrbNode for in-memory use.
            </p>
            <br>
            <py-repl>
# Create some DrbLogicalNode them try to access different data to this node.
from drb.utils.logical_node import DrbLogicalNode
node = DrbLogicalNode(source='my_first_node', namespace_uri='the_namespace', value="9999")
node.append_child(DrbLogicalNode(source=f'the_children_of_the_node', parent=node, value=10000))
            </py-repl>
            <span style="padding: 5%;">Tip: press Shift-ENTER to evaluate a cell</span>
            <br>
            <br>


            <br>
            <p>Use the property name of the drbNode to print the name of the node</p>
            <p class="code">def name: str</p>
            <p>Returns the name of the item. This name does not contain any prefix,path nor any other location or identification part.</p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output3" std-err="err-div"> </py-repl>
                <div id="output3" class="p-4"></div>
            </py-box>
            <input type="button" onclick = "clearBox('output3')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output3', 'my_first_node')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output3', 'node.name')" value="Show soluce"/>


            <p>Use the property namespace_uri of the drbNode to print the namespace_uri of the node</p>
            <p class="code">def namespace_uri: Optional[str]</p>
            <p>Get namespace URI. The namespace URI of this item. This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.</p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output4" std-err="err-div"> </py-repl>
                <div id="output4" class="p-4"></div>
            </py-box>

            <input type="button" onclick = "clearBox('output4')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output4', 'the_namespace')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output4', 'node.namespace_uri')" value="Show soluce"/>

            <p>Use the property value of the node to retrieve the value.</p>
            <p class="code">def value: Optional[Any]</p>
            <p>The value of the item.</p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output5" std-err="err-div"> </py-repl>
                <div id="output5" class="p-4"></div>
            </py-box>

            <input type="button" onclick = "clearBox('output5')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output5', '9999')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output5', 'node.value')" value="Show soluce"/>

            <p>Use the property parent to check if the node has a parent (here it should print None because the node has no parent)</p>
            <p class="code">def parent: Optional[drb.node.DrbNode]</p>
            <p>The parent of this node. Returns a reference to the parent node of the current node according to the current implementation. Most of the nodes have a parent except root nodes or if they have just been removed, etc. If the node has no parent the operation returns None.</p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output6" std-err="err-div"> </py-repl>
                <div id="output6" class="p-4"></div>
            </py-box>

            <input type="button" onclick = "clearBox('output6')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output6', 'None\n')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output6', 'print(node.parent)')" value="Show soluce"/>

            <p>Call the property path of the node (you can call the name of the parsed path)</p>
            <p class="code">def path: drb.path.ParsedPath</p>
            <p>The full path of this node. The path is the complete location of this node. The supported format is URI and apache common VFS.</p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output7" std-err="err-div"> </py-repl>
                <div id="output7" class="p-4"></div>
            </py-box>
            
            <input type="button" onclick = "clearBox('output7')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output7', 'my_first_node')" value="Check Output"/>
            <input  type="button" onclick = "reveale_soluce('output7', 'node.path')" value="Show soluce"/>

            <h2 class="chapter"> DrbNode Attributes</h3>
            
            <br>
            <p> 
                The attributes of a DrbNode are here to describes the node.
                You can get the list of all the attributes of a node by calling the property attributes of
                by calling the method get_attribute
            </p>
            <br>

            <py-repl>
node.add_attribute('content_size', '140')
node.add_attribute('content_type', 'text/char')               
            </py-repl>

            <p>Please execute the cell above and then try using the attributes property to print all the attributes. Check if an attributes is present.</p>
            <p class="code">def attributes(self) -> Dict[Tuple[str, str], Any]</p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output8" std-err="err-div"> </py-repl>
                <div id="output8" class="p-4"></div>
            </py-box>
            <input type="button" onclick = "clearBox('output8')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output8', '{(\'content_size\', None): \'140\', (\'content_type\', None): \'text/char\'}')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output8', 'node.attributes')" value="Show soluce"/>

            <p>You can also use the get_attribute methode to retrieve a specific attribute by his name and his namespace if he has one.</p>
            <p class="code"> def get_attribute(self, name: str, namespace_uri: str = None) -> Any</p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output9" std-err="err-div"> </py-repl>
                <div id="output9" class="p-4"></div>
            </py-box>
            <input type="button" onclick = "clearBox('output9')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output9', '140')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output9', 'node.get_attribute(\'content_size\')')" value="Show soluce"/>


        <h2 class="chapter"> Navigation between DrbNode</h3>
        
            <img src="static/images/First_Example.png">
            <br>

            <p>The tree of data above has been created using DrbLogicalNode.</p>
                
            <br>

            <py-repl>
# Create some DrbLogicalNode them try to access different data to this node.
from drb.utils.logical_node import DrbLogicalNode
node = DrbLogicalNode(source='my_awesome_parent', namespace_uri='a_namespace', parent=None)
for i in range(3):
    node.append_child(DrbLogicalNode(source=f'child_{i+1}', parent=node, value=i+1))
node.append_child(DrbLogicalNode(source=f'child_3', parent=node, value=10, namespace_uri='ns'))
node.append_child(DrbLogicalNode(source=f'child_3', parent=node, value=20, namespace_uri='ns'))
            </py-repl>
            
            <br>

                <p>To access the list of all the children of a node you can call the property children</p>
                <p class="code">def children(self) -> List[DrbNode]</p>
                <p>The list of children of the current node. Returns a list of child references ordered by the current node's driver. The current node may have no child and the operation returns therefore an empty List.</p>
    
                <py-box widths="2/3;1/3">
                    <py-repl std-out="output10" std-err="err-div"> </py-repl>
                    <div id="output10" class="p-4"></div>
                </py-box>
    
                <input type="button" onclick = "clearBox('output10')" value="Clear Output"/>
                <input type="button" onclick = "check_value('output10', '[1, 2, 3, 10, 20]')" value="Check Output"/>
                <input type="button" onclick = "reveale_soluce('output10', 'node.children')" value="Show soluce"/>
            <p>
                You can navigate between a node and his children using their name, namespace or their index, you also find the list of all the children of a node with the method children.
            </p>
            <p>
                Since the AbstractNode implements the getitem methods that allow us to navigate between node using brackets. 
            </p>
            <p class="code">def __getitem__(self, item)</p>
            <br>
            <py-repl>
# get first child
print(node[0])
            </py-repl>
            <br>
            <py-repl>
# get last child
node[-1]
            </py-repl>
            <br>
            <py-repl>
# get children interval (last 3 children)
[e for e in node[-3:-1]]  
            </py-repl>
            <br>
            <py-repl>
# get the first child by it name
print(node['child_3'])
print(node['child_3',0]) 
            </py-repl>
            <br>
            <py-repl>
# third child named child_3
node['child_3',2]  
            </py-repl>
            <br>
            <py-repl>
# children interval of child named child_3 (first 2 children)
[e for e in node['child_3', :2]] 
            </py-repl>
            <br>
            <py-repl>
# first child named child_3 and having as namespace ns
node['child_3', 'ns']  
            </py-repl>
            <br>
            <py-repl>
# all children named child_3 and having as namespace ns
[e for e in node['child_3', 'ns', :]]
            </py-repl>
            <br>            
            <br>

            <p>
                Property flag to decide about behaviour during browsing of its children. This flag is transitive from a parent to its child until the first definition using this property setter. Default value False
            </p>
            <p class="code">def namespace_aware: bool</p>
            <br>
            <py-repl>
node.namespace_aware = False

# Get all children with name child_3 irrelevant for namespace
print([e for e in node['child_3', :]])

# Set the namespace_aware flag to True
node.namespace_aware = True

# Get all children with name child_3 and no namespace
print([e for e in node['child_3', :]])


# Get all children with name child_3 and a namespace ns
print([e for e in node['child_3', 'ns', :]])
            </py-repl>


            <br>

            <p>
                To check if a node has a specific children or any children you can call the has_child method
            </p>
            <p class="code">def has_child(self, name: str = None, namespace: str = None) -> bool</p>
            <p>
                You call also call the keyword in to check if a children with the name given in comparaison is present.
            </p>
            <br>
            <py-repl>
# Check if the parent has one or more children
print(node.has_child())  
            </py-repl>
            <br>
            <py-repl>
# Check if the parent has one or more children named child_3
print(node.has_child('child_3'))
print('child_3' in node)  
            </py-repl>
            <br>
            <py-repl>
# Check if the parent has one or more children named child_3 with a namespace ns
print(node.has_child('child_3', 'ns'))
print(('child_3', 'ns') in node)  
            </py-repl>
            <br>
            <py-repl>
# Check if the parent has one or more children named child_1 with a namespace ns
print(node.has_child('child_1', 'ns'))
print(('child_1', 'ns') in node)  
            </py-repl>
            <br>
            <py-repl>
# Check if the parent has one or more children named child_3 with a namespace no
print(node.has_child('child_3', 'no'))
print(('child_3', 'no') in node)
            </py-repl>
        </section>
        
        <br>

        <section>
            <h2 class="chapter">Time to code</h2>

            <br>
            <br>
            <img src="static/images/drb_node_ex.png">
            
            <p>The nodes created in the cell below represent the tree of data in the diagram just above.</p>
            <br/>
            <py-repl>
# Create some DrbLogicalNode them try to access different data to this node.
from drb.utils.logical_node import DrbLogicalNode

node = DrbLogicalNode(source='Th_parent', value=0)
for i in range(3):
    node.append_child(DrbLogicalNode(source=f'Child_{i+1}', parent=node, value=i+1))
node.append_child(DrbLogicalNode(source=f'Child_1', parent=node, value=4, namespace_uri='The_twin'))
            </py-repl>

            <br/>
            <p>
                Please using the parent node created above, retrieve all the data asked.
                <br/>
                Please recover the list of all the name of the children.
            </p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output11" std-err="err-div"></py-repl>
                <div id="output11" class="p-4"></div>
            </py-box>
            
            <br/>
            <input id="btn11" type="button" onclick = "clearBox('output11')" value="Clear Output"/>
            <input id="check11" type="button" onclick = "check_value('output11', '[\'Child_1\', \'Child_2\', \'Child_3\', \'Child_1\']')" value="Check Output"/>
            <input id="soluce11" type="button" onclick = "reveale_soluce('output11', '[e.name for e in node]')" value="Show soluce"/>
        
            <br/>
            <p>
                Please recover the list of the first and third children value.
            </p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output12" std-err="err-div"></py-repl>
                <div id="output12" class="p-4"></div>
            </py-box>
            
            <br/>
            <input type="button" onclick = "clearBox('output12')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output12', '[1, 3]')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output12', '[e.value for e in node[0::2]]')" value="Show soluce"/>
            <br/>

            <p>
                Please check if the node has a child called child_1 with no namespace.
            </p>

            <py-box widths="2/3;1/3">
                <py-repl std-out="output13" std-err="err-div"></py-repl>
                <div id="output13" class="p-4"></div>
            </py-box>
            
            <br/>
            <input type="button" onclick = "clearBox('output13')" value="Clear Output"/>
            <input type="button" onclick = "check_value('output13', 'True')" value="Check Output"/>
            <input type="button" onclick = "reveale_soluce('output13', 'node.has_child(\'Child_1\', None)')" value="Show soluce"/>
            <br/>  
    </section>
        <br/>
        <br/>
        <footer>
        <p><A HREF="logical_node.html">Logical Node</A></p>
        <p><A HREF="/">Home Page</A></p>
        </footer>

        <footer id="err-div" class="bg-red-700 text-white text-center border-t-4 border-green-500 fixed inset-x-0 bottom-0 p-4 hidden"/>
    </article>
</html>
